Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::ModalBar Class Reference

STK resonant bar instrument class. More...

`#include <ModalBar.h>`

Inheritance diagram for stk::ModalBar:

## Public Member Functions

| ModalBar (void)
| Class constructor.
| ~ModalBar (void)
| Class destructor.
void | setStickHardness (StkFloat hardness)
| Set stick hardness (0.0 - 1.0).
void | setStrikePosition (StkFloat position)
| Set stick position (0.0 - 1.0).
void | setPreset (int preset)
| Select a bar preset (currently modulo 9).
void | setModulationDepth (StkFloat mDepth)
| Set the modulation (vibrato) depth (0.0 - 1.0).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
Public Member Functions inherited from stk::Modal
| Modal (unsigned int modes=4)
| Class constructor, taking the desired number of modes to create.
virtual | ~Modal (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
virtual void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | setRatioAndRadius (unsigned int modeIndex, StkFloat ratio, StkFloat radius)
| Set the ratio and radius for a specified mode filter.
void | setMasterGain (StkFloat aGain)
| Set the master gain.
void | setDirectGain (StkFloat aGain)
| Set the direct gain.
void | setModeGain (unsigned int modeIndex, StkFloat gain)
| Set the gain for a specified mode filter.
virtual void | strike (StkFloat amplitude)
| Initiate a strike with the given amplitude (0.0 - 1.0).
void | damp (StkFloat amplitude)
| Damp modes with a given decay factor (0.0 - 1.0).
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.
Public Member Functions inherited from stk::Instrmnt
| Instrmnt (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK resonant bar instrument class.

This class implements a number of different struck bar instruments. It inherits from the Modal class.

Control Change Numbers:

- Stick Hardness = 2
- Stick Position = 4
- Vibrato Gain = 1
- Vibrato Frequency = 11
- Direct Stick Mix = 8
- Volume = 128
- Modal Presets = 16
  - Marimba = 0
  - Vibraphone = 1
  - Agogo = 2
  - Wood1 = 3
  - Reso = 4
  - Wood2 = 5
  - Beats = 6
  - Two Fixed = 7
  - Clump = 8

by Perry R. Cook and Gary P. Scavone, 1995–2023.

The documentation for this class was generated from the following file:

- ModalBar.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.